/*	$Id: joymng.h,v 1.2 2004/07/26 15:53:26 monaka Exp $	*/

/*-
 * Copyright (c) 2004 NONAKA Kimihiro <aw9k-nnk@asahi-net.or.jp>,
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef	NP2_X11_JOYMNG_H__
#define	NP2_X11_JOYMNG_H__

/*
 * joystick manager
 */

#ifdef __cplusplus
extern "C" {
#endif

#define	JOY_NAXIS		2
#define	JOY_NBUTTON		4
#define	JOY_AXIS_INVALID	0xff
#define	JOY_BUTTON_INVALID	0xff
#define	JOY_NAXIS_MAX		(JOY_AXIS_INVALID-1)
#define	JOY_NBUTTON_MAX		(JOY_BUTTON_INVALID-1)

enum JOYINFO_JOYFLAG {
	JOY_UP_BIT		= (1 << 0),
	JOY_DOWN_BIT		= (1 << 1),
	JOY_LEFT_BIT		= (1 << 2),
	JOY_RIGHT_BIT		= (1 << 3),
	JOY_RAPIDBTN1_BIT	= (1 << 4),
	JOY_RAPIDBTN2_BIT	= (1 << 5),
	JOY_BTN1_BIT		= (1 << 6),
	JOY_BTN2_BIT		= (1 << 7)
};

typedef struct {
	int axis[JOY_NAXIS];
	int button[JOY_NBUTTON];

	int naxis;
	int nbutton;

	int devindex;
	char *devname;
} joydrv_handle_common, *joydrv_handle_t;


#if defined(SUPPORT_JOYSTICK)

void joymng_initialize(void);
void joymng_deinitialize(void);
const joydrv_handle_t *joymng_get_devinfo_list(void);
void joymng_sync(void);
REG8 joymng_getstat(void);
void joymng_update(void);

REG8 joymng_getstat_with_map(UINT8 *axismap, UINT8 *btnmap);
int joymng_update_task(void *p);

#else	/* !SUPPORT_JOYSTICK */

#define	joymng_initialize()		(np2oscfg.JOYPAD1 |= 2)
#define	joymng_deinitialize()		(np2oscfg.JOYPAD1 &= 1)
#define	joymng_get_devinfo_list()	NULL
#define	joymng_sync()
#define	joymng_getstat()		(REG8)0xff
#define	joymng_update()

#endif	/* SUPPORT_JOYSTICK */

#ifdef __cplusplus
}
#endif

#endif	/* NP2_X11_JOYMNG_H__ */
